<template>
    <div :id='id' style="width:100%;height:100%; position:relative;">
      <template v-if="field.displayType == Constant.PermissionType_HIDDEN">
				<!--隐藏-->
				{{field.hiddenValue}}
			</template>

      <template v-else-if="field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      
      </template>

      <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
        <!-- <button @click="searchLocation">点击</button> -->
        <div class="change-map">
          <span @click="normalMap()" :class="mapNum==1?'map-color':''">{{$t('map')}}</span>
          <span @click="mixMap()" :class="mapNum==2?'map-color':''">{{$t('satellite')}}</span>
        </div>
        <baidu-map
          id="box"
          :center="center" 
          :zoom="zoom"  
          class="bm-view"
          :mapType="currentMapType"
          @dblclick="getDbclickInfo"
          :double-click-zoom = "false"
          @zoomend="zoomEnd"
          @ready="handler"
          >
          <bm-marker 
            v-if="markerHidden" 
            :position="markerPoint" 
            :dragging="true" @click="infoWindowOpen">
            <bm-info-window 
              :show="show" 
              @close="infoWindowClose" 
              @open="infoWindowOpen"
              style="width:280px;height:220px;"
            >
              <!-- {{markerAdress}} -->
              <div class="address-wrap">
                <div>{{$t('address')}}：</div>
                <div class="info">{{markerAdress}}</div>
                <div class="common">
                  <div>{{$t('addTitle')}}：</div>
                  <input  placeholder="" v-model="adressTitle"></input>
                </div>
                <div class="common">
                  <div>{{$t('addContent')}}：</div>
                  <input  placeholder="" v-model="adressContent"></input>
                </div>
                <div class="add-btn">
                  <span>
                    <input type="button" class="btns" :value="$t('confirm')" @click.stop.prevent="onOk()">
                  </span>
                  <span>
                    <input type="button" class="btns" :value="$t('reset')" @click.stop.prevent="onReset">
                  </span>
                </div>
              </div>
            </bm-info-window>
          </bm-marker>
          <!-- <bm-map-type :map-types="['BMAP_NORMAL_MAP', 'BMAP_HYBRID_MAP']" anchor="BMAP_ANCHOR_TOP_RIGHT"></bm-map-type> -->
          <bm-navigation anchor="BMAP_ANCHOR_BOTTOM_RIGHT"></bm-navigation>
          <bm-geolocation 
            anchor="BMAP_ANCHOR_TOP_RIGHT"
            :showAddressBar="true" 
            :autoLocation="true">
          </bm-geolocation>
          
          <bm-control :offset="{width: '10px', height: '10px', top:'50px'}">
            <bm-auto-complete v-model="location" :sugStyle="{zIndex: 1}">
               <div style="width:200px;border:1px solid #ccc;margin-top: 50px;margin-left:10px;">
                 <van-field :value="location" placeholder="请输入地名关键字" />
               </div>
            </bm-auto-complete>
          </bm-control>
          <bm-local-search 
            :keyword="location" 
            :auto-viewport="true" 
            style="display: none"
          >
          </bm-local-search>
        </baidu-map>
      </template>
    </div>
</template>

<script>
import Constant from "@/Constant.js";
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-map",
  props: ["id"],
  computed: {
    field: function() {
      return this.$parent.findField(this.id);
    },
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
		return {
      Constant,
      center: {
        lng: 113.261503, 
        lat: 23.131377
      },
      zoom: 9,
      isActive:false,
      currentMapType:"BMAP_NORMAL_MAP",
      mapNum:1,
      currentLongitude:"",
      currentLatitude:"",
      keyword: '',
      location:'',
      show: false,
      markerPoint: {
        lng:'',
        lat:'',
      },
      markerAdress:'',
      adressTitle:'',
      adressContent:'',
      markerHidden:true,
		}
  },
  
  methods: {
    handler ({BMap}) {
      let that = this;	// 设置一个临时变量指向vue实例，因为在百度地图回调里使用this，指向的不是vue实例；
      var geolocation = new BMap.Geolocation();
      geolocation.getCurrentPosition(function(r){
        that.center = {
          lng: r.longitude, 
          lat: r.latitude,
        };
        that.zoom = 17;
      })
    },
    showPosition(position){
      debugger
    },
    zoomEnd(e){
      this.zoom = e.target.getZoom();
    },
    //右键放大
    enlargeMap(e){
      this.center = {
        lng: e.point.lng,
        lat: e.point.lat
      };
      this.zoom = this.zoom+2;
      if(this.zoom>=19){
        this.zoom = 19;
      }

    },
    //右键缩小
    reduceMap(e){
      this.center = {
        lng: e.point.lng,
        lat: e.point.lat
      };
      this.zoom = this.zoom-2;
      if(this.zoom<=0) {
        this.zoom = 1
      }
    },
    setSign(e){
      let mLng = e.point.lng,
          mLat = e.point.lat;
      this.setMark(mLng, mLat);
    },
    cancelSign({BMap, map}){
      //有问题，隐藏
      this.markerHidden = false;
      console.log(BMap, map);
    },
    infoWindowClose () {
      this.show = false
    },
    infoWindowOpen () {
      debugger
      this.show = true
    },
    getDbclickInfo (e) {
      let mLng = e.point.lng,
          mLat = e.point.lat;
      this.setMark(mLng, mLat);
    },
    // setMark(mLng, mLat, close){
    //   let that = this;
    //   let myGeo = new BMap.Geocoder();
    //   let p = new BMap.Point(mLng, mLat);
    //   myGeo.getLocation(p, function(rs){
    //     let addComp = rs.addressComponents;
    //     let address = addComp.province+addComp.city+addComp.district+addComp.street+addComp.streetNumber;
    //     that.markerAdress = address;
    //     that.markerPoint.lng = mLng;
    //     that.markerPoint.lat = mLat;
    //     that.markerHidden = true;
    //     if(close == true) {
    //       that.show = false
    //     }else {
    //       that.show = true;
    //     }
    //   });
    // },
    normalMap(){
      if(this.mapNum == 2) {
        this.currentMapType = "BMAP_NORMAL_MAP"
        this.mapNum = 1;
      }
    },
    mixMap(){
      if(this.mapNum == 1) {
        this.currentMapType = "BMAP_HYBRID_MAP"
        this.mapNum = 2;
      }
    },
    searchLocation(){
      this.location = '广东省广州市越秀区华乐街道环市东路403号广州国际电子大厦1802'//this.keyword;
    },
    searchBox(e) {

      this.isActive = !this.isActive;
    },
  }
}
</script>

<style lang="scss">
  .bm-view {
    margin:0 auto;
    width: 100%;
    // height: 100%;
    height: 600px;
  }
  .isHidden {
    display: none;
  }
  .btns{
    padding:2px 7px;
    font-size: 11px;
  }
  .change-map {
    width:75px;
    height:20px;
    position:absolute;
    // right:36px;
    // top:40px;
    left: 20px;
    top: 20px;
    z-index:5000;
    display:-webkit-flex;
    display: flex;
    flex-direction: row;
    background:white;
    border:1px solid #8ea8e0;
    border-radius: 4px;
    overflow: hidden;
    -webkit-box-shadow:2px 2px 4px #8ea8e0;  
    -moz-box-shadow:2px 2px 4px #8ea8e0;  
    box-shadow:2px 2px 4px #8ea8e0; 
    span {
      cursor:pointer;
      display:block;
      width:50%;
      height:20px;
      line-height: 20px;
      text-align: center;
      font-size:12px;
    }
  }
  .map-color{
    background:#8ea8e0;
    color:white;
    font-weight:bold;
  }
  .address-wrap {
    width:100%;
    &>div{
      width:100%;
      display:-webkit-flex;
      display: flex;
      flex-direction:row;
      &>div{
        height:40px;
        line-height:40px;
        vertical-align:middle;
        white-space:nowrap;
      }
      &:first-child {
        margin: 5px 0 10px 0;
        font-weight: bold;
      }
    }
    .info {
      margin-bottom:30px;
    }
    .common {
      margin-bottom: 15px;
    }
    .add-btn {
      display: -webkit-flex;
      display:flex;
      justify-content: center;
      &>span {
        margin-right:30px;
      }
    }
  }
</style>